#include <stdlib.h>
#include <string.h>
#include "ver.h"
#include <cstdio>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

typedef pair<int,int> PI;

oi::Scanner in(stdin);

const int maxn = 1000;

void massert(bool c, char* msg)
{
    if (!c)
        in.error(msg);
}

vector<int> p;

int find(int x)
{
    if (p[x]==x)
        return x;
    p[x] = find(p[x]);
    return p[x];
}

void link(int x, int y)
{
    p[find(x)] = find(y);
}

int main() 
{
    int TT = in.readInt(1, 1e9);
    in.readEoln();
    while (TT--) 
    {
        int n = in.readInt(2,maxn);
        p.resize(n);
        vector<int> deg(n,0);
        for(int i=0; i<n; i++)
            p[i] = i;
        in.readEoln();
        for(int i=0; i<n-1; i++)
        {
            int a = in.readInt(1,n);
            in.readSpace();
            int b = in.readInt(1,n);
            in.readEoln();
            massert(a!=b, "Krawedz-petla!\n");
            a--; b--;
            massert(find(a)!=find(b), "Cykl!\n");
            link(a,b);
            deg[a]++;
            deg[b]++;
            massert(deg[a]<=10,"Wierzcholek o stopniu >= 10!\n");
            massert(deg[b]<=10,"Wierzcholek o stopniu >= 10!\n");
        }
        int q = in.readInt(1,n*(n-1)/2);
        in.readEoln();
        set<PI> S;
        for(int i=0; i<q; i++)
        {
            int a = in.readInt();
            in.readSpace();
            int b = in.readInt();
            in.readEoln();
            massert(a!=b,"Poczatek i koniec sciezki rowne!\n");
            if (a>b)
                swap(a,b);
            massert(S.find(PI(a,b))==S.end(),"Ta sama sciezka wystepuje na wejsciu dwukrotnie!\n");
            S.insert(PI(a,b));
        }
        p.clear();
        printf("OK, n = %d, q = %d.\n",n,q);
    }
    return 0;
}
