// Author: Witold Jarnicki

#include <cstdio>

using namespace std;

long long MaxPowerOf2(const long long N) {
  long long ret = 1;
  while (N % (2 * ret) == 0) ret *= 2;
  return ret;
}

void Solve() {
  long long N;
  scanf("%lld", &N);
  long long e = 2 * MaxPowerOf2(N);
  long long o = 2;
  while (o * o <= N && o < e) {
    if (N % o == 0) {
      if (o % 2) e = o;
      const int No = N / o;
      if (No < e) if (No % 2) e = No;
    }
    ++o;
  }
  // N / e - srodkowa
  // (N/e) - (e-1)/2 > 0
  // 2*N > e*(e-1)
  if (2 * N <= e * (e - 1)) {
    printf("IMPOSSIBLE\n");
    return;
  }
  printf("%lld = ", N);
  long long current = N / e - (e - 1) / 2;
  for (long long i = 0; i < e; ++i) {
    if (i) printf(" + ");
    printf("%lld", current++);
  }
  printf("\n");
}

int main() {
  int T;
  scanf("%d", &T);
  while (T--) Solve();
  return 0;
}
