// Author: Adam Polak
#include <algorithm>
#include <iostream>
#include <queue>
#include <vector>
#include <utility>
using namespace std;

__uint128_t gcd(__uint128_t a, __uint128_t b) {
  while (b > 0) {
    a = a % b;
    swap(a, b);
  }
  return a;
}

int main() {
  ios_base::sync_with_stdio(false);
  int Z;
  cin >> Z;
  while (Z--) {
    int n; 
    cin >> n;
    vector<int> x(n), y(n), r(n);
    for (int i = 0; i < n; ++i)
      cin >> x[i] >> y[i] >> r[i];
    vector<__uint128_t> a(n), b(n);
    vector<bool> visited(n, false);
    vector<bool> ccw(n);
    a[0] = b[0] = 1;
    queue<int> q;
    q.push(0);
    visited[0] = true;
    while (!q.empty()) {
      int u = q.front();
      q.pop();
      for (int v = 0; v < n; ++v) {
        if (!visited[v] && (x[u] - x[v]) * (x[u] - x[v]) + (y[u] - y[v]) * (y[u] - y[v]) == (r[u] + r[v]) * (r[u] + r[v])) {
          a[v] = a[u] * r[u];
          b[v] = b[u] * r[v];
          ccw[v] = !ccw[u];
          q.push(v);
          visited[v] = true;
        }
      }
    }
    for (int i = 0; i < n; ++i) {
      if (!a[i]) {
        cout << "not moving\n";
      } else {
        __uint128_t d = gcd(a[i], b[i]);
        a[i] /= d;
        b[i] /= d;
        cout << (int)a[i];
        if (b[i] > 1)
          cout << "/" << (int)b[i];
        cout << " " << (ccw[i] ? "counter" : "") << "clockwise" << endl;
      }
    }
  }
}
