// Author: Adam Polak
// O(n^2)

#include <algorithm>
#include <iostream>
#include <queue>
#include <vector>
#include <utility>
using namespace std;

int gcd(int a, int b) {
  while (b > 0) {
    a = a % b;
    swap(a, b);
  }
  return a;
}

int main() {
  ios_base::sync_with_stdio(false);
  int Z;
  cin >> Z;
  while (Z--) {
    int n; 
    cin >> n;
    vector<int> x(n), y(n), r(n);
    for (int i = 0; i < n; ++i)
      cin >> x[i] >> y[i] >> r[i];
    vector<int> a(n, -1), b(n, -1);
    vector<bool> ccw(n);
    a[0] = b[0] = 1;
    queue<int> q;
    q.push(0);
    while (!q.empty()) {
      int u = q.front();
      q.pop();
      for (int v = 0; v < n; ++v) {
        if (a[v] == -1 && (x[u] - x[v]) * (x[u] - x[v]) + (y[u] - y[v]) * (y[u] - y[v]) == (r[u] + r[v]) * (r[u] + r[v])) {
          a[v] = a[u] * r[u];
          b[v] = b[u] * r[v];
          int d = gcd(a[v], b[v]);
          a[v] /= d;
          b[v] /= d;
          ccw[v] = !ccw[u];
          q.push(v);
        }
      }
    }
    for (int i = 0; i < n; ++i) {
      if (a[i] == -1) {
        cout << "not moving\n";
      } else {
        cout << a[i];
        if (b[i] > 1)
          cout << "/" << b[i];
        cout << " " << (ccw[i] ? "counter" : "") << "clockwise" << endl;
      }
    }
  }
}
