#include <fstream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <iostream>
#include "testlib.h"

using namespace std;

void collapse(vector<int> &numbers) {
  if (numbers.size() < 2) return;
  if (numbers[numbers.size()-2] == numbers[numbers.size()-1]) {
    numbers.pop_back();
    numbers.back() *= 2;
    collapse(numbers);
  }
}

bool viable(const vector<int> &numbers) {
  for (int i = 1; i < (int)numbers.size() - 1; ++i)
    if (numbers[i] < numbers[i-1] && numbers[i] < numbers[i+1])
      return false;
  return true;
}

int main(int argc, char **argv) {

registerTestlibCmd(argc, argv);

  int Z, tn=0;
  Z= inf.readInt();
  vector<int> data;
  while (Z--) {
    int n;
    tn+=2;
    n=inf.readInt();
    data.clear();
    while (n--) {
      int k=inf.readInt();
      data.push_back(k);
    }
    string hint, sol;
    hint=ans.readToken();
    sol=ouf.readToken();
    if (sol != "no") {
      assert(sol.size() == data.size());
      for (int i = 0; i < sol.size(); ++i) {
        assert(sol[i] == 'l' || sol[i] == 'r');
      }
    }
    if(hint == "no" && sol != "no") {
      quitf (_wa,"error in test starting in line %d",tn);
    }
    if(hint != "no" && sol == "no") {
      quitf (_wa,"error in test starting in line %d",tn);
    }
    if (sol == hint) continue;
    vector<int> numbers;
    for (int i = 0; i < data.size(); ++i) {
      if (sol[i] == 'l') {
        reverse(numbers.begin(), numbers.end());
        numbers.push_back(data[i]);
        collapse(numbers);
        reverse(numbers.begin(), numbers.end());
      } else {
        numbers.push_back(data[i]);
        collapse(numbers);
      }
      assert(viable(numbers));
    }
    if(numbers.size() != 1) {
      quitf (_wa,"did not reduce %d",tn);
    }
  }
  quitf (_ok,"OK!");
}
