#include <stdio.h>
#include <stdlib.h>
#include <string.h>
// Author: Arkadiusz Pawlik

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<pair<int, int> > data;
int n;

void no_spells(vector<int> *result) {
  int so_far = 0;
  result->resize(n);
  for (int i = n-1; i >= 0; --i) {
    (*result)[i] = so_far = max(so_far, data[i].first-data[i].second);
  }
}

void cast_a_spell(const vector<int> &previous, vector<int> *result) {
  int so_far = 0;
  result->resize(n);
  for (int i = n-1; i >= 0; --i) {
    int cast_result = (i+1 < n ? previous[i+1] : 0) - data[i].second;
    int no_cast_result = data[i].first - data[i].second;
    (*result)[i] = so_far = max(so_far, min(cast_result, no_cast_result));
  }
}

bool comp(const pair<int,int>&a,const pair<int,int>&b) {
  return a.second-a.first>b.second-b.first;
}

void test() {
  int k;
  cin >> n >> k;
  data.clear();
  for (int i = 0; i < n; ++i) {
    int v, c;
    cin >> v >> c;
    data.push_back(make_pair(v, c));
  }
  sort(data.begin(), data.end(), comp);
  vector<int> result;
  no_spells(&result);
  for (int i = 0; i < k; ++i) {
    vector<int> tmp;
    cast_a_spell(result, &tmp);
    result.swap(tmp);
  }
  cout << result.front() << endl;
}


int main() {
  int Z;
  cin >> Z;
  while (Z--) {
    test();
  }
}
