#include <stdlib.h>
#include <string.h>
// Author: Lech Duraj
// Solution recovery

#include <cstdio>
#include <algorithm>

using namespace std;

typedef pair<int,int> PI;

const int maxn = 150000;
const int maxk = 9;

const int infty = 2e9;

PI A[maxn];
int B[maxk+1][maxn+1];
int R[maxk+1][maxn+1];


int main()
{
  int TT;
  scanf("%d",&TT);
  while(TT--)
  {
    int n,k;
    scanf("%d %d",&n,&k);
    for(int i=0; i<n; i++)
      scanf("%d %d",&A[i].first,&A[i].second);
    sort(A,A+n);
    B[0][n] = -infty;
    for(int q=0; q<=k; q++)
      for(int i=0; i<=n; i++)
        R[q][i] = 0;
    for(int i=n-1; i>=0; i--)
    {
      if (A[i].first-A[i].second>B[0][i+1])
        R[0][i] = 1;
      B[0][i] = max(B[0][i+1],A[i].first-A[i].second);
    }
    for(int q=1; q<=k; q++)
    {
      B[q][n] = -infty;
      R[q][n] = 0;
      for(int i=n-1; i>=0; i--)
      {
        int u,r;
        B[q][i] = B[q][i+1];
        R[q][i] = 0;
        if (A[i].first-A[i].second<B[q-1][i+1]-A[i].second)
        {
            r = 1;
            u = A[i].first - A[i].second;
        } else
        {
            r = 2;
            u = B[q-1][i+1] - A[i].second;
        }
        if (u>B[q][i+1])
        {
            B[q][i] = u;
            R[q][i] = r;
        }
        if (i+q>n)
        {
          B[q][i] = -infty;
          R[q][i] = 0;
        }
      }
    }
    printf("%d\n",max(B[k][0],0));
    int q = k;
    for(int i=0; i<n; i++)
    {
        if (R[q][i]==0)
            continue;
        if (R[q][i]>0)
        {
            fprintf(stderr," %d [%d,%d] (%d)",i,A[i].first,A[i].second,A[i].first - A[i].second);
    //        fprintf(stderr,"x ");
        }
        q--;
        if (q<0)
            break;
    }
    fprintf(stderr,"\n");
  }
}

