#include <stdlib.h>
#include <string.h>
#include <algorithm>
#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#define INT64 "%I64d"
#else
#define INT64 "%lld"
#endif

#if ( _WIN32 || __WIN32__ || _WIN64 || __WIN64__ )
#define UNS64 "%I64u"
#else
#define UNS64 "%llu"
#endif
// Author: Robert Obryk
#include <cstdio>
#include <vector>
#include <cassert>

using namespace std;

struct scase {
    vector<pair<int, bool> > poses; 
    long long pop[2];

    void dostuff() {
        int n;
        pop[0] = pop[1] = 0;
        scanf("%d", &n);
        while (n--) {
            int k;
            char sc[100];
            scanf("%d %s", &k, sc);
            bool c = false;
            assert(sc[1] == '\0');
            if (sc[0] == 'B')
                c = true;
            else 
                assert(sc[0] == 'W');
            poses.push_back(make_pair(k, c));
            pop[c == true] += k;
        }
        if (pop[0] == 0) {
            printf(INT64 "\n", pop[1]);
            return;
        }
        if (pop[1] == 0) {
            printf(INT64 "\n", pop[0]);
            return;
        }

        int res = 0;
        long long popsofar[2];
        popsofar[0] = popsofar[1] = 0;
        for(int i=0;i<poses.size();i++) {
            bool col = poses[i].second;
            __int128 a = popsofar[col == true], b = popsofar[col == false];
            __int128 c = pop[col == true], d = pop[col == false];
            __int128 xd = b*c - a*d;
            if (xd % d == 0) {
                __int128 x = xd/d; // XXX inttype everywhere
                if (x >= 0 && x < poses[i].first) {
                    res++;
                }
            }
            popsofar[col == true] += poses[i].first;
        }
        printf("%d\n", res);
    }

};

int main()
{
    int T;
    scanf("%d", &T);
    while (T--) {
        scase s;
        s.dostuff();
    }
    return 0;
}
