// Author: Adam Polak
#include <cstdlib>
#include <fstream>
#include <iostream>
#include "testlib.h"
using namespace std;

int GetRow(int x) {
  if (x > 0)
    return (x - 1) / 3;
  else
    return 3;
}

int GetCol(int x) {
  if (x > 0)
    return (x - 1) % 3;
  else
    return 1;
}

bool LessEq(int x, int y) {
  return GetRow(x) <= GetRow(y) && GetCol(x) <= GetCol(y);
}

bool IsOk(int sec) {
  if (sec < 10)
    return true;
  else
    return LessEq((sec / 10) % 10, sec % 10);
}

int main(int argc, char **argv) {
registerTestlibCmd(argc, argv);

  int Z;
  Z=inf.readInt();
  while (Z--) {
    int n_in, n_hint, n_out;
    n_in = inf.readInt();
    n_hint=ans.readInt();
    n_out=ouf.readInt();
    if (abs(n_hint - n_in) != abs(n_out - n_in)) {
      quitf (_wa,"%d is not optimal for %d, %d is better",n_out,n_in,n_hint);
    }
    if (!IsOk(n_out)) {
      quitf (_wa,"%s is not valid choice",n_out);
    }
  }
  quitf (_ok,"OK!");
}
