#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <vector>
#include <string>
#include <ctime>
#include <queue>
#include <map>
#include <set>

#ifdef WIN32
    #define I64 "%I64d"
#else
    #define I64 "%lld"
#endif // WIN32

#define next(x) (x + ((x) & (-x)))
#define prev(x) (x - ((x) & (-x)))
#define N 2002
#define md 1000000007
#define sqr(x) ((x) * (x))
#define INF (1 << 30)
#define EPS 0.00000001

using namespace std;
const int maxn = 1003;

struct circle
{
public:

    int x, y, r;

    bool istouch(circle const & c) const
    {
        return (x - c.x) * (x - c.x) + (y - c.y) * (y - c.y) == (r + c.r) * (r + c.r);
    }
};

bool used[maxn], rot[maxn];
circle c[maxn];
int n;



void dfs(int v, bool dir)
{
    used[v] = true;
    rot[v] = dir;
    for (int i = 0; i < n; i++)
    {
        if (!used[i] && c[v].istouch(c[i]))
            dfs(i, !dir);
    }
}

int gcd(int x, int y)
{
    while (x != 0 && y != 0)
        if (x > y)
            x %= y;
        else y %= x;
}

int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // DEBUG

    int t;
    cin >> t;
    for (int s = 0; s < t; s++)
    {
        cin >> n;
        for (int i = 0; i < n; i++)
            cin >> c[i].x >> c[i].y >> c[i].r;
        rot[0] = true;
        dfs(0, rot[0]);
        for (int i = 0; i < n; i++)
    {
        if (!used[i])
            cout << "not moving" << endl;
        else
        {
            int a, b;
            a = c[0].r, b = c[i].r;
            if (a % b == 0)
                cout << a / b << ' ';
            else
            {
                int nod = gcd(a, b);
                a /= nod;
                b /= nod;
                cout << a << '/' << b << ' ';
            }
            if (rot[i])
                cout << "clockwise" << endl;
            else
                cout << "counterclockwise" << endl;
            used[i] = false;
        }
    }
    }



    return 0;
}
