#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

struct point {
	int x, y;
	point():x(0), y(0) {}
	point(int x, int y):x(x), y(y) {}
	point operator+(const point& o) const {
		return point(x+o.x,y+o.y);
	}
	point operator-(const point& o) const {
		return point(x-o.x,y-o.y);
	}
	ll operator*(const point& o) const {
		return x*(ll)o.y-y*(ll)o.x;
	}
	ll operator%(const point& o) const {
		return x*(ll)o.x+y*(ll)o.y;
	}
	point rot() const {
		return point(-y,x);
	}
};

struct hull {
	vector<point> v;
	hull() {}
	hull(const vector<point>& a) {
		int n = sz(a);
		v.pb(a[0]);
		for(int i = 1; i < n; ++i) {
			point cur = a[i];
			while (sz(v) > 1) {
				point pr = v.back();
				point ppr = v[sz(v)-2];
				if ((pr-ppr)*(cur-pr) >= 0) v.pop_back();
				else break;
			}
			v.pb(cur);
		}
	}
	point getpoint(const point& n) {
		int l = -1;
		int r = sz(v)-1;
		while (r-l>1) {
			int m = (l+r)>>1;
			point cur = v[m].rot();
			if (n * cur >= 0) l = m;
			else r = m;
		}
		point best = v[0];
		for (int i = l-7; i <= l+7; ++i) {
			if (i < 0 || i >= sz(v)) continue;
			if (best % n < v[i] % n) best = v[i];
		}
		return best;
	}
};

const int maxn = 100010;

hull t[maxn*4];
vector<point> pts;
void build(int v, int L, int R) {
	t[v] = hull(vector<point>(pts.begin()+L,pts.begin()+R+1));
	if (L == R) return;
	int m = (L+R)>>1;
	build(v+v+1,L,m);
	build(v+v+2,m+1,R);
}

int query(int v, int L, int R, int l, int r, const point& p1, const point& p2) {
	if (l > r) return -1;
	if (L > r || l > R) return -1;
	point norm = (p2-p1).rot();
	point tmp = t[v].getpoint(norm);
	if ((p2-p1)*(tmp-p1) <= 0) return -1;
	if (L == R) return L;
	int m = (L+R)>>1;
	int v1 = query(v+v+1,L,m,l,r,p1,p2);
	if (v1 != -1) return v1;
	return query(v+v+2,m+1,R,l,r,p1,p2);
}

void solve() {
	int n; scanf("%d", &n);
	pts.resize(n);
	forn(i, n) scanf("%d%d", &pts[i].x, &pts[i].y);
	build(0,0,n-1);
	forn(i, n-1) {
		int ans = query(0,0,n-1,i+2,n-1,pts[i],pts[i+1]);
		if (ans == -1) ans = 0;
		printf("%d ", ans);
	}
	printf("\n");
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	int T; scanf("%d", &T); while (T--) solve();
	return 0;
}
