#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e3+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

int n, m;
int p[maxn];
pii e[maxn];
int tin[maxn];
int timer;
int P[maxn];
int lca[maxn];
vector < int > g[maxn];
bool vis[maxn];
int level[maxn];
bool used[maxn];

void dfs(int v, int par, int degree){
	p[v] = par;
	level[v] = degree;
	tin[v] = timer++;
	forit(it, g[v]){
		int to = *it;
		if ( to == par ) continue;
		dfs(to, v, degree+1);
	}
}

int getlca(int a, int b){
	memset(used, 0, sizeof(used));

	if ( level[a] > level[b] ) swap(a, b);

    while ( a != -1 ){
    	used[a] = true;
    	a = p[a];
    }
    while ( true ){
    	int par = p[b];
    	if ( used[par] ) return par;
    	b = par;
    }
}

bool cmp(int i, int j){
	return tin[lca[i]] < tin[lca[j]];
}


void clean(){
	for (int i=1;i<=n;i++) g[i].clear();
	memset(used, 0, sizeof(used));	
	memset(tin, 0, sizeof(tin));
	timer = 0;
	memset(P, 0, sizeof(P));
	memset(vis, 0, sizeof(vis));
	memset(lca, 0, sizeof(lca));
	memset(level, 0, sizeof(level));
	memset(p, 0, sizeof(p));
}

bool isValid(int a, int b){
	if ( vis[b] ) return false;
	while ( a != b ){
		if ( vis[a] ) return false; 
		a = p[a];
	}
	return true;
}

bool valid(int pos){
	int a = e[pos].f;
	int b = e[pos].s;
	int LCA = lca[pos];
	return isValid(a, LCA) && isValid(b, LCA);
}

void brush(int a, int b){
	if ( a == b ) return;
	while ( a != b ){
		vis[a] = true;
		a = p[a];
	}
}

void process(int pos){
	int a = e[pos].f;
	int b = e[pos].s;
	int LCA = lca[pos];
	brush(a, LCA);
	brush(b, LCA);	
}


void Solve(){
	scanf("%d", &n);
	clean();
	for (int i=0;i<n-1;i++){
		int a, b;
		scanf("%d%d", &a, &b);
		g[a].pb(b);
		g[b].pb(a);
	}
	dfs(1, -1, 0);

	scanf("%d", &m);
	for (int i=0;i<m;i++){
		int a, b;
		scanf("%d%d", &a, &b);
		e[i] = mp(a, b);
		lca[i] = getlca(a, b);
	}
	for (int i=0;i<m;i++) P[i] = i;
	sort(P, P + m, cmp);
	reverse(P, P + m);

	int ans = 0;

	for (int i=0;i<m;i++){
		int I = P[i];
		if ( valid(I) ){
			ans++;
			process(I);
		}	
	}
	printf("%d\n", ans);
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	int t;
	scanf("%d", &t);

	for (int i=0;i<t;i++){
		Solve();
	}

	


	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
