#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <fstream>
#include <cassert>
#include <map>
#include <set>
#include <vector>
#include <queue>
#include <stack>
#include <functional>
#include <numeric>
#include <ctime>
#include <cstdlib>
#include <sstream>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define pii pair<int, int>
#define pll pair<long long, long long>
#define y1 stupid_y1
#define ll long long
#define vi vector<int>
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(a) a.begin(), a.end()
#define sqr(x) ((x)*(x))
#define sz(a) (int)a.size()
#define file "a"

const int maxn = (int)1e3+11;
const int inf = int(1e9);
const int mod = inf + 7;
const double eps = 1e-9;
const double pi = acos(-1.0);

struct Rational {
	int sgn;
	ll p, q;

	Rational () {}
	Rational (ll _p, ll _q) {
		p = _p;
		q = _q;
		ll d = __gcd(p, q);
		if(d) p /= d; q /= d;
	}
	Rational (int val) {
		p = val;
		q = 1;
	}

	void print() {
		if(p) {
			if(q > 1) cout << p << "/" << q;
			else cout << p;
			if(sgn) printf(" clockwise\n");
			else printf(" counterclockwise\n");
		} else printf("not moving\n");
	}

	Rational const operator +(Rational o) {
		ll up = p * o.q + q * o.p;
		ll down = q * o.q;
		return Rational(up, down);
	}
	Rational const operator -(Rational o) {
		ll up = p * o.q - q * o.p;
		ll down = q * o.q;
		return Rational(up, down);
	}
	Rational const operator *(Rational o) {
		ll up = p * o.p;
		ll down = q * o.q;
		return Rational(up, down);
	}
	Rational const operator /(Rational o) {
		ll up = p * o.q;
		ll down = q * o.p;
		return Rational(up, down);
	}
} a[maxn];

int n;
int x[maxn], y[maxn], r[maxn];
vi g[maxn];
bool used[maxn];

bool ok(int i, int j) {
	int R = sqr(r[i] + r[j]);
	int d = sqr(x[i] - x[j]) + sqr(y[i] - y[j]);
	return R >= d;
}

void apply(int v, int to) {
	Rational f = a[v];
	Rational s = Rational(0);
	Rational temp = Rational(r[v], r[to]);
	s = f * temp;
	s.sgn = 1-f.sgn;
	a[to] = s;
}

void dfs(int v) {
	used[v] = 1;
	forit(it, g[v]) {
		int to = *it;
		if(!used[to]) {
			apply(v, to);
			dfs(to);
		}
	}
}

void solve() {
	scanf("%d", &n);
	for(int i = 0; i < n; i++)
		scanf("%d%d%d", x + i, y + i, r + i);

	for(int i = 0; i < n; i++) g[i].clear();

	for(int i = 0; i < n; i++)
		for(int j = i + 1; j < n; j++) {
			if(ok(i, j)) {
				g[i].pb(j);
				g[j].pb(i);
			}
		}

	for(int i = 0; i < n; i++) a[i] = Rational(0);

	a[0] = Rational(1);
	a[0].sgn = 1;

	for(int i = 0; i < n; i++) used[i] = false;
	dfs(0);

	for(int i = 0; i < n; i++) a[i].print();
}

int main () {

	#ifdef LOCAL
	freopen(file".in", "r", stdin);
	freopen(file".out", "w", stdout);
	#endif

	
	int t;

	scanf("%d", &t);

	while(t--) solve();

	#ifdef LOCAL
	cerr << (double)clock() * 1.0 / CLOCKS_PER_SEC << endl;
	#endif

	return 0;
}
