#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>
#include <cmath>

#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;

const int kMaxN = 10000;

ll gcd(ll a, ll b) {
	return (b == 0) ? a : gcd(b, a % b);
}

struct Fraction {
	ll a, b;
	
	Fraction() : a(1), b(1) {}
	Fraction(ll a, ll b) : a(a), b(b) {}
	
	void print() {
		if(b == 1) printf("%lld", a);
		else printf("%lld/%lld", a, b);
	}
};

int tests, n;
int xs[kMaxN], ys[kMaxN], rs[kMaxN];
queue < int > q;
bool used[kMaxN], color[kMaxN];
Fraction results[kMaxN];

Fraction multiply(Fraction x, Fraction y) {
	ll na = x.a * y.a;
	ll nb = x.b * y.b;
	ll g = gcd(na, nb);
	return Fraction(na / g, nb / g);
}

bool isEdge(int u, int v) {
		int dx = xs[u] - xs[v];
		int dy = ys[u] - ys[v];
		double distance = sqrt(dx * dx + dy * dy);
		double needDistance = rs[u] + rs[v];
		return abs(distance - needDistance) < 1e-9;
}

void solve() {
	scanf("%d", &n);
	for(int i = 0; i < n; i++) scanf("%d%d%d", &xs[i], &ys[i], &rs[i]);
	q.push(0);
	memset(used, 0, sizeof(used));
	used[0] = true;
	while(!q.empty()) {
		int u = q.front(); q.pop();
		for(int v = 0; v < n; v++) {
			if(!used[v] && isEdge(u, v)) {
				q.push(v);
				color[v] = !color[u];
				used[v] = true;
				results[v] = multiply(results[u], Fraction(rs[u], rs[v]));
			}
		}
	}
	for(int i = 0; i < n; i++) {
		if(!used[i]) printf("not moving\n");
		else {
			results[i].print();
			if(color[i])
				printf(" counterclockwise\n");
			else
				printf(" clockwise\n");
		}
	}
}

int main() {
	scanf("%d", &tests);
	while(tests--) solve();
	return 0;
}