#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;

struct Block {
	ll howMuch;
	bool color;
};

ll gcd(ll i, ll j) {
	return (j == 0 ? i : gcd(j, i % j));
}

ll check(int n, const vector < Block > & blocks, ll whiteRatio, ll blackRatio) {
	ll whiteCount = 0, blackCount = 0, result = 0;
	const ll inf = 0;
	for(int i = 0; i < n; i++) {
		if(blocks[i].color) {
			whiteCount += blocks[i].howMuch;
			ll k = min(whiteCount / whiteRatio, blackCount / blackRatio);
			//cout << k << endl;
			if(k > 0 && k * blackRatio == blackCount && (whiteCount - k * whiteRatio) <= blocks[i].howMuch) {
				whiteCount -= k * whiteRatio;
				blackCount -= k * blackRatio;
				++result;
			}
		} else {
			blackCount += blocks[i].howMuch;
			ll k = min(whiteCount / whiteRatio, blackCount / blackRatio);
			//cout << k << endl;
			if(k > 0 && k * whiteRatio == whiteCount && (blackCount - k * blackRatio) <= blocks[i].howMuch) {
				whiteCount -= k * whiteRatio;
				blackCount -= k * blackRatio;
				++result;
			}
		}
	}
	//cout << whiteRatio << " " << blackRatio << " " << result << endl;
	return (whiteCount == 0 && blackCount == 0 ? result : 0);
}

ll checkDumb(int n, const vector < Block > & blocks, ll whiteRatio, ll blackRatio) {
	vector < bool > line;
	for(int i = 0; i < n; i++) {
		for(int j = 0; j < blocks[i].howMuch; j++)
			line.push_back(blocks[i].color);
	}
	int m = line.size();
	vector < int > d(m + 1, 0);
	for(int i = 0; i < m; i++) {
		for(int j = 0; j <= i; j++) {
			int a = 0, b = 0;
			for(int k = j; k <= i; k++) {
				if(line[k])
					++a;
				else
					++b;
			}
			int k0 = a / whiteRatio, k1 = b / blackRatio;
			if(k0 == k1 && k0 * whiteRatio == a && k1 * blackRatio == b) {
				d[i + 1] = max(d[i + 1], d[j] + 1);
			}
		}
	}
	return d[m];
}

/*void factorize(ll n, vector < ll > & result) {
	for(ll i = 1; i * i <= n; i++) {
		if(n % i == 0) {
			ll j = n / i;
			result.pb(i);
			if(i != j) result.pb(j);
		}
	}
}*/

void solveOne(bool print) {
	int blocksCount;
	cin >> blocksCount;
	vector < Block > blocks(blocksCount);
	ll blackSum = 0, whiteSum = 0;
	for(int i = 0; i < blocksCount; i++) {
		cin >> blocks[i].howMuch;
		string s;
		cin >> s;
		blocks[i].color = (s[0] == 'W');
		if(blocks[i].color)
			whiteSum += blocks[i].howMuch;
		else
			blackSum += blocks[i].howMuch;
		if(print)
			cout << blocks[i].howMuch << " " << blocks[i].color << endl;
	}
	//cout << "WTF" << endl;
	if(blackSum == 0) {
		cout << whiteSum << "\n";
	} else if(whiteSum == 0) {
		cout << blackSum << "\n";
	} else {
		// vector < ll > intX, intY;
		//factorize(whiteSum, intX);
		//factorize(blackSum, intY);
		//random_shuffle(intX.begin(), intX.end());
		//random_shuffle(intY.begin(), intY.end());
		ll g = gcd(whiteSum, blackSum);
		whiteSum /= g;
		blackSum /= g;
		ll result = check(blocksCount, blocks, whiteSum, blackSum);
		//assert(result == checkDumb(blocksCount, blocks, whiteSum, blackSum));
		cout << result << "\n";
	}
}

int main() {
	srand(22);
	ios_base::sync_with_stdio(0);
	int tests;
	cin >> tests;
	for(int test = 0; test < tests; test++)
		solveOne(false);
	return 0;
}