#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>

#include <iostream>
#include <iomanip>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <stack>
#include <algorithm>


#define forn(i, n) for(int i = 0; i < int(n); i++)
#define mp make_pair
#define pb push_back
#define foreach(it, v) for(__typeof(v.begin()) it = v.begin(); it != v.end(); ++it)

using namespace std;

typedef long long ll;

struct Box {
	int profit, cost;
	
	bool operator < (const Box & other) const {
		return (profit - cost) < (other.profit - other.cost);
	}
};

bool check(int boxesCount, int canDestroy, const vector < Box > & boxes, int currentProfit) {
	int maxWeightBefore = 0;
	const int inf = 1e9;
	
	//cout << "CHECK
	
	++canDestroy;
	
	vector < bool > can(canDestroy + 1, false);
	can[0] = true;
	
	vector < int > minWeight(canDestroy + 1, inf);
	minWeight[0] = 0;
	
	for(int i = 0; i < boxesCount; i++) {
		const Box & box = boxes[i];
		if(box.profit >= currentProfit) {
			for(int j = canDestroy - 1; j >= 0; j--) {
				if(can[j]) {
					int thisBoxAsLastProfit = -minWeight[j] - box.cost + box.profit;
					if(thisBoxAsLastProfit >= currentProfit) {
						can[j + 1] = true;
						minWeight[j + 1] = min(minWeight[j + 1], minWeight[j] + box.cost);
					}
				}
			}
			
			if(can[canDestroy])
				return true;
		}
	}
	
	return false;
}

void solve() {
	int boxesCount, canDestroy;
	cin >> boxesCount >> canDestroy;
	vector < Box > boxes(boxesCount);
	int maxProfit = 0;
	for(int i = 0; i < boxesCount; i++) {
		cin >> boxes[i].profit >> boxes[i].cost;
		maxProfit = max(maxProfit, boxes[i].profit);
	}
	sort(boxes.begin(), boxes.end());
	//vector < bool > used(boxesCount);
	int result = 0;
	if(canDestroy < boxesCount) {
		int l = 0, r = maxProfit + 1;
		while(r - l > 1) {
			int m = (l + r) / 2;
			if(check(boxesCount, canDestroy, boxes, m))
				l = m;
			else
				r = m;
		}
		result = l;
	}
	cout << result << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	int tests;
	cin >> tests;
	while(tests--)
		solve();
	return 0;
}