import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Arrays;
import java.util.Scanner;


public class Main {
	
	static class MyReader {
		BufferedInputStream in;

		final int bufSize = 1 << 16;
		final byte b[] = new byte[bufSize];

		MyReader( InputStream in ) {
			this.in = new BufferedInputStream(in, bufSize);
		}

		int nextInt() throws IOException {
			int c;
			while ((c = nextChar()) <= 32)
				;
			int x = 0, sign = 1;
			if (c == '-') {
				sign = -1;
				c = nextChar();
			}
			while (c >= '0') {
				x = x * 10 + (c - '0');
				c = nextChar();
			}
			return x * sign;
		}

		StringBuilder _buf = new StringBuilder();
		String nextWord() throws IOException {
			int c;
			_buf.setLength(0);
			while ((c = nextChar()) <= 32)
				;
			while (c > 32) {
				_buf.append((char)c);
				c = nextChar();
			}
			return _buf.toString();
		}

		int bn = bufSize, k = bufSize;
		
		int nextChar() throws IOException {
			if (bn == k) {
				k = in.read(b, 0, bufSize);
					bn = 0;
			}
			return bn >= k ? -1 : b[bn++];
		}

		int nextNotSpace() throws IOException {
			int ch;
			while ((ch = nextChar()) <= 32 && ch != -1)
				;
			return ch;
		}
	}
	
	static boolean[] isPrime;
	static {
		isPrime = new boolean[100000];
		Arrays.fill(isPrime, true);
		isPrime[0] = false;
		isPrime[1] = false;
		for (int i=2; i<100000; ++i) {
			if (isPrime[i]) {
				for (long j=(long)i*(long)i; j<100000; j*=i) {
					isPrime[(int)j] = false;
				}
			}
		}
	}
	
	public static void main(String[] args) throws IOException {
		MyReader in = new MyReader(System.in);
		int t = in.nextInt();
		int[] blocks = new int[100000];
		for (int test = 0; test<t; ++test) {
			int N = in.nextInt();
			for (int i=0;i<N;++i) blocks[i]=0;
			int count = 0;
			char current = '1';
			for (int i=0; i<N; ++i) {
				int val = in.nextInt();
				char ch = (char) in.nextNotSpace();
				if (ch == current) --count;
				current = ch;
				if (ch == 'B') blocks[count] += val; // B +
				else blocks[count] -= val;           // W -
				++count;
			}
			int B = 0;
			int W = 0;
			for (int i=0; i<count; ++i) {
				if (blocks[i]>0) B+=blocks[i];
				else W -= blocks[i];
			}
			if (B==0 || W==0) {
				System.out.println(B+W);
				continue;
			}
			
			
			int sqrt = Math.min ((int)Math.sqrt(B), (int)Math.sqrt(W));
			for (int i=1; i<=sqrt; ++i) {
				if (B % i == 0) {
					int j = B/i;
					if (W % i == 0) {
						B /= i;
						W /= i;
					}
					if (W % j == 0) {
						B /= j;
						W /= j;
					}
				}
				if (W % i == 0) {
					int j = W/i;
					if (B % i == 0) {
						B /= i;
						W /= i;
					}
					if (B % j == 0) {
						B /= j;
						W /= j;
					}
				}
			}
			//System.out.println(B+" "+W);
			/*int sqrt = Math.min ((int)Math.sqrt(B), (int)Math.sqrt(W));
			for (int i=2; i<=sqrt; ++i) {
				if (isPrime[i]) {
					while (B % i == 0 && W % i == 0) {
						B /= i;
						W /= i;
					}
				}
			}
			if (B % W == 0) {
				B = B/W;
				W = 1;
			}
			if (W % B == 0) {
				W = W/B;
				B = 1;
			}*/
			//System.out.println(B+" "+W);
			
			int result = 0;
			
			int currentB = 0;
			int currentW = 0;
			int index = 0;
			while (index < count) {
				if (blocks[index] > 0) { //B
					currentB += blocks[index];
					if (currentW != 0 && currentW % W == 0) {
						int needB = ( (currentW / W) * B);
						if (needB >= currentB - blocks[index] && needB <= currentB) {
							++result;
							currentW = 0;
							currentB -= needB;
						}
					}
				} else {
					currentW -= blocks[index];
					if (currentB != 0 && currentB % B == 0) {
						int needW = ( (currentB / B) * W);
						if (needW >= currentW + blocks[index] && needW <= currentW) {
							++result;
							currentB = 0;
							currentW -= needW;
						}
					}
				}
				++index;
			}
			System.out.println(result);
			
		}
	}
	
	/*static int[] x = new int[1000];
	static int[] y = new int[1000];
	static int[] r = new int[1000];
	
	static int[] primes;
	static {
		int MAXPRIME = 20000;
		boolean[] notprime = new boolean[MAXPRIME];
		notprime[0] = true;
		notprime[1] = true;
		for (int i=2; i<MAXPRIME; ++i) {
			if (!notprime[i]) {
				for (int j=i+1; j<MAXPRIME; ++j) {
					if (j%i==0) {
						notprime[j] = true;
					}
				}
			}
		}
		int count = 0;
		for (int i=0;i<MAXPRIME;++i) {
			if (!notprime[i]) ++count;
		}
		primes = new int[count];
		count = 0;
		for (int i=2;i<MAXPRIME;++i) {
			if (!notprime[i]) primes[count++] = i;
		}
	}
	
	public static class Drobnoe {
		long p;
		long q;
		public Drobnoe(long p, long q) {
			if (q==0) {throw new IllegalArgumentException();}
			this.p = p;
			this.q = q;
			trim();
		}
		private void trim() {
			for (int i=0; i<primes.length; ++i) {
				if (q < primes[i]) break;
				while (p%primes[i] == 0 && q%primes[i] == 0) {
					p /= primes[i];
					q /= primes[i];
				}
			}
		}
		public void out() {
			System.out.print(Math.abs(p));
			if (q != 1) {
				System.out.print('/');
				System.out.print(q);
			}
			System.out.println(p>0 ? " clockwise" : " counterclockwise");
		}
	}
	
	public static boolean isTouch(int i, int j) {
		if (i==j) return false;
		return (x[i]-x[j])*(x[i]-x[j]) + (y[i]-y[j])*(y[i]-y[j]) == (r[i]+r[j])*(r[i]+r[j]); 
	}
	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int t = in.nextInt();
		for (int test = 0; test<t; ++test) {
			int N = in.nextInt();
			for (int i=0;i<N;++i) {
				x[i] = in.nextInt();
				y[i] = in.nextInt();
				r[i] = in.nextInt();
			}
			
			Drobnoe[] result = new Drobnoe[N];
			result[0] = new Drobnoe(1, 1);
			
			boolean[] used = new boolean[N];
			
			while (true) {
				int j=-1;
				for (int i=0; i<N; ++i) {
					if (!used[i] && result[i] != null) {
						j = i;
						used[i] = true;
						break;
					}
				}
				if (j == -1) break;
				for (int i=0; i<N; ++i) {
					if (result[i] == null && isTouch(i, j)) {
						result[i] = new Drobnoe(-result[j].p * r[j], result[j].q * r[i]);
					}
				}
			}
			
			for (int i=0; i<N; ++i) {
				if (result[i] == null) {
					System.out.println("not moving");
				} else {
					result[i].out();
				}
			}
			
		}
	}*/
	/*public static int right(int key) {
		switch (key) {
			case 1:
				return 2;
			case 2:
				return 3;
			case 4:
				return 5;
			case 5:
				return 6;
			case 7:
				return 8;
			case 8:
				return 9;
		}
		return -1;
	}
	
	public static int down(int key) {
		switch (key) {
			case 1:
				return 4;
			case 2:
				return 5;
			case 3:
				return 6;
			case 4:
				return 7;
			case 5:
				return 8;
			case 6:
				return 9;
			case 8:
				return 0;
		}
		return -1;
	}
	
	public static int cur_sum;
	public static int target;
	
	public static void bruteforce(int currentKey, int currentValue) {
		//System.out.println(currentKey+" "+currentValue);
		if (currentKey == -1) return;
		if (currentKey == 0 && currentValue == 0) return;
		int cur_diff = Math.abs(cur_sum - target);
		int this_diff = Math.abs(currentValue - target);
		//System.out.println(this_diff+" "+cur_diff);
		if (this_diff < cur_diff) {
			cur_sum = currentValue;
		}
		if (currentValue > target) {
			return;
		}
		bruteforce(currentKey, currentValue*10 + currentKey);
		bruteforce(right(currentKey), currentValue);
		bruteforce(down(currentKey), currentValue);
	}
	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int t = in.nextInt();
		for (int test = 0; test<t; ++test) {
			target = in.nextInt();
			cur_sum = 0;
			bruteforce(1, 0);
			System.out.println(cur_sum);
		}
	}*/
	
	/*public static int sum(int N) {
		long lN = (long)N;
		long result = (lN*(lN+1))/2L;
		return (int)result;
	}
	
	public static int check(int N, int count) {
		int M = (N-sum(count-1));
		//System.out.println(N + " " + count);
		if (M % count == 0) {
			return M/count;
		}
		return -1;
	}
	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int t = in.nextInt();
		for (int test = 0; test<t; ++test) {
			int N = in.nextInt();
			if (N==1) {
				System.out.println("IMPOSSIBLE");
				continue;
			}
			int count = 2;
			int cmax = ((int)Math.sqrt(N)) * 2;
			while (check(N, count) == -1 && count < cmax) {
				++count;
			}
			if (check(N, count) == -1) {
				System.out.println("IMPOSSIBLE");
				continue;
			}
			StringBuilder buf = new StringBuilder();
			buf.append(N).append(" = ");
			int start = check(N, count);
			buf.append(start);
			for (int i=1;i<count;++i) {
				buf.append(" + ").append(start+i);
			}
			System.out.println(buf);
		}
	}*/

}
