#include <iostream>
#include <queue>
#include <algorithm>
#include <map>
using namespace std;

inline int GetBit(int mask, int i)
{
    return (mask >> i) & 1;
}

const int kMaxN = 1e3;

int n;
int a[kMaxN];
int lower_bit[1 << 12];
int sum[kMaxN];
int sum_deg;

short pr[1 << 12][1 << 12][14];
int test;

struct State
{
    int mask_first;
    int mask_second;
    int central_bit;

    State(int a, int b, int c) :
        mask_first(a),
        mask_second(b),
        central_bit(c)
    {
    }

    State()
    {
    }
};

map<State, pair<State, int> > mp_pr;

queue<State> q;

bool operator < (const State& q, const State& p)
{
    return q.mask_first < p.mask_first ||
        (q.mask_first == p.mask_first &&
        q.mask_second < p.mask_second) ||
        (q.mask_first == p.mask_first &&
         q.mask_second == p.mask_second &&
         q.central_bit < p.central_bit);
}

inline bool NotUsed(int mask_first, int mask_second, int central_bit)
{
    return mp_pr.find(State(mask_first, mask_second, central_bit)) == mp_pr.end();
  //  return pr[mask_first][mask_second][central_bit] / 3 != test ||
    //        pr[mask_first][mask_second][central_bit] % 3 == 0;
}

void ShowAnswer(int mask_first, int mask_second, int central_bit)
{
    string answer;
    answer.resize(n);
    State cur(mask_first, mask_second, central_bit);
    for (int pos = 0; pos < n; ++pos) {
        answer[pos] = mp_pr[cur].second;
        if (answer[pos] == 1) {
            answer[pos] = 'l';
        } else {
            answer[pos] = 'r';
        }
        cur = mp_pr[cur].first;
        /*
        if (pr[mask_first][mask_second][central_bit] % 3 == 1) {
            answer[pos] = 'l';
            if (mask_first < val) {
                --central_bit;
                mask_first += (1 << central_bit);
            }
            mask_first -= val;
        } else {
            answer[pos] = 'r';
            if (mask_second < val) {
                --central_bit;
                mask_second += (1 << central_bit);
            }
            mask_second -= val;
        }
        */
    }
    reverse(answer.begin(), answer.end());
    cout << answer << endl;
}

inline void ShowMask(int mask)
{
    for (int i = 0; i < 12; ++i) {
        cout << GetBit(mask, i);
    }
}

State cur;

inline void UpdatePos(int mask_first, int mask_second, int central_bit, int val)
{
    if (NotUsed(mask_first, mask_second, central_bit)) {
        State temp(mask_first, mask_second, central_bit);
        mp_pr[temp] = make_pair(cur, val);
        q.push(State(mask_first, mask_second, central_bit));
    }
    /*
    if (NotUsed(mask_first, mask_second, central_bit)) {
        pr[mask_first][mask_second][central_bit] = 3 * test + val;
        //cout << "Added STATE = ";
        //ShowMask(mask_first);
        //cout << " " << central_bit << " ";
        //ShowMask(mask_second);
        //cout << endl;
        q.push(State(mask_first, mask_second, central_bit));
    }
    */
}

void BFS()
{
    pr[0][0][a[0]] = test * 3 + 1;
    q.push(State(0, 0, a[0]));
    int cur_pos = 1;
    while (!q.empty()) {
        cur = q.front();

        q.pop();

        if (cur.mask_first + cur.mask_second + (1 << cur.central_bit) > sum[cur_pos - 1]) {
            ++cur_pos;
        }

        if (cur_pos == n) {
            continue;
        }

        if (cur.mask_first == 0) {
            if (a[cur_pos] > cur.central_bit) {
                UpdatePos(0, cur.mask_second + (1 << cur.central_bit), a[cur_pos], 1);
            } else if (a[cur_pos] == cur.central_bit) {
                UpdatePos(0, cur.mask_second, cur.central_bit + 1, 1);
            } else {
                UpdatePos(1 << a[cur_pos], cur.mask_second, cur.central_bit, 1);
            }
        } else {
            if (a[cur_pos] <= lower_bit[cur.mask_first]) {
                int new_mask = cur.mask_first + (1 << a[cur_pos]);

                if (new_mask < (1 << cur.central_bit)) {
                    UpdatePos(new_mask, cur.mask_second, cur.central_bit, 1);
                } else if (new_mask == (1 << cur.central_bit)) {
                    UpdatePos(0, cur.mask_second, cur.central_bit + 1, 1);
                } else {
                    UpdatePos(0, cur.mask_second + (1 << cur.central_bit), lower_bit[new_mask], 1);
                }
            }
        }

        if (cur.mask_second == 0) {
            if (a[cur_pos] > cur.central_bit) {
                UpdatePos(cur.mask_first + (1 << cur.central_bit), 0, a[cur_pos], 2);
            } else if (a[cur_pos] == cur.central_bit) {
                UpdatePos(cur.mask_first, 0, cur.central_bit + 1, 2);
            } else {
                UpdatePos(cur.mask_first, 1 << a[cur_pos], cur.central_bit, 2);
            }
        } else {
            if (a[cur_pos] <= lower_bit[cur.mask_second]) {
                int new_mask = cur.mask_second + (1 << a[cur_pos]);

                if (new_mask < (1 << cur.central_bit)) {
                    UpdatePos(cur.mask_first, new_mask, cur.central_bit, 2);
                } else if (new_mask == (1 << cur.central_bit)) {
                    UpdatePos(cur.mask_first, 0, cur.central_bit + 1, 2);
                } else {
                    UpdatePos(cur.mask_first + (1 << cur.central_bit), 0, lower_bit[new_mask], 2);
                }
            }
        }
    }

    if (!NotUsed(0, 0, sum_deg)) {
        ShowAnswer(0, 0, sum_deg);
    } else {
        cout << "no" << endl;
    }
}

int main()
{
   // freopen("input.txt", "r", stdin);
  //  freopen("output.txt", "w", stdout);

    for (int mask = 0; mask < (1 << 12); ++mask) {
        lower_bit[mask] = 12;
        for (int i = 0; i < 12; ++i) {
            if (GetBit(mask, i)) {
                lower_bit[mask] = i;
                break;
            }
        }
    }

    ios_base::sync_with_stdio(false);

    int tests;
    cin >> tests;
    for (test = 1; test <= tests; ++test) {
        cin >> n;
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
            if (i == 0) {
                sum[i] = a[i];
            } else {
                sum[i] = a[i] + sum[i - 1];
            }
            for (int j = 0; j <= 13; ++j) {
                if ((1 << j) == a[i]) {
                    a[i] = j;
                    break;
                }
            }
        }

        sum_deg = -1;
        for (int i = 0; i <= 13; ++i) {
            if ((1 << i) == sum[n - 1]) {
                sum_deg = i;
                break;
            }
        }

        if (sum_deg == -1) {
            cout << "no" << endl;
            continue;
        }

        BFS();
    }

    return 0;
}
