#include <iostream>
#include <string>
#include <cstdio>
using namespace std;

const int kModulo = 1e9 + 9;

void ModuloInc(int& x, int y)
{
    x += y;
    if (x >= kModulo) {
        x -= kModulo;
    }
}

int GetBit(int mask, int i)
{
    return (mask >> i) & 1;
}

string s[3];

int dp[2][4];

int tr[4][4][28][28][28];

void Do(int prev_mask, int c1, int c2, int c3,
                        int pc1, int pc2, int pc3)
{
    if (pc1 == 27 && c1 == 0) {
        return ;
    }
    if (pc2 == 27 && c2 == 0) {
        return ;
    }
    if (pc3 == 27 && c3 == 0) {
        return ;
    }

    int new_mask = prev_mask;

    if (GetBit(prev_mask, 0) != 1 && c1 > c2) {
        return ;
    }

    if (GetBit(prev_mask, 1) != 1 && c2 > c3) {
        return ;
    }

    if (GetBit(prev_mask, 0) != 1 && c1 < c2) {
        new_mask += 1;
    }

    if (GetBit(prev_mask, 1) != 1 && c2 < c3) {
        new_mask += 2;
    }

    tr[prev_mask][new_mask][pc1][pc2][pc3] += 1;
}

void CalcSteps()
{
    for (int prev_mask = 0; prev_mask < 4; ++prev_mask) {
        for (int c1 = 0; c1 < 27; ++c1) {
            for (int c2 = 0; c2 < 27; ++c2) {
                for (int c3 = 0; c3 < 27; ++c3) {
                    Do(prev_mask, c1, c2, c3, c1, c2, c3);
                    Do(prev_mask, c1, c2, c3, 27, c2, c3);
                    Do(prev_mask, c1, c2, c3, c1, 27, c3);
                    Do(prev_mask, c1, c2, c3, c1, c2, 27);
                    Do(prev_mask, c1, c2, c3, 27, 27, c3);
                    Do(prev_mask, c1, c2, c3, 27, c2, 27);
                    Do(prev_mask, c1, c2, c3, c1, 27, 27);
                    Do(prev_mask, c1, c2, c3, 27, 27, 27);
                }
            }
        }
    }

}

void AddLength(string& s, int n)
{
    int m = s.length();

    s.resize(n);
    for (int i = m; i < n; ++i) {
        s[i] = 'a' - 1;
    }
}

int LetterToInt(char c)
{
    if (c == '?') {
        return 27;
    }
    return c - ('a' - 1);
}

int main()
{
   // freopen("input.txt", "r", stdin);

    ios_base::sync_with_stdio(false);

    CalcSteps();

    int tests;
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        for (int i = 0; i < 3; ++i) {
            cin >> s[i];
        }
        int cur = 0;
        int prev = 1;

        for (int mask = 0; mask < 4; ++mask) {
            dp[cur][mask] = 0;
        }

        dp[cur][0] = 1;

        int n = (int) max(s[0].length(), max(s[1].length(), s[2].length()));

        AddLength(s[0], n);
        AddLength(s[1], n);
        AddLength(s[2], n);

        for (int i = 0; i < n; ++i) {
            for (int mask = 0; mask < 4; ++mask) {
                dp[prev][mask] = 0;
            }
            int c1 = LetterToInt(s[0][i]);
            int c2 = LetterToInt(s[1][i]);
            int c3 = LetterToInt(s[2][i]);
            for (int prev_mask = 0; prev_mask < 4; ++prev_mask) {
                for (int cur_mask = 0; cur_mask < 4; ++cur_mask) {
                    ModuloInc(dp[prev][cur_mask], (1LL * dp[cur][prev_mask] * tr[prev_mask][cur_mask][c1][c2][c3]) % kModulo);

                }
            }
            swap(cur, prev);
        }

        cout << dp[cur][3] << endl;
    }

    return 0;
}
