#include <cstdio>
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <memory.h>
#include <queue>
#include <deque>
#include <stack>
#include <list>
#include <map>
#include <set>
#include <functional>
#include <cstring>
#include <ctime>

using namespace std;

#define all(a) a.begin(), a.end()
#define mp make_pair

typedef long long li;
typedef long double ld;
typedef pair<int, int> pi;
typedef vector<int> vi;

#define FILENAME ""

int timerR = 0;

void solve();
void prec();

int main() {
#ifdef YA
	string s = FILENAME;
	//assert(!s.empty());
	clock_t start = clock();
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen(FILENAME ".in", "r", stdin);
	//freopen(FILENAME ".out", "w", stdout);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif
	cout.sync_with_stdio(0);
	cin.tie(0);
	cout.precision(15);
	cout << fixed;

	int t = 1;
	prec();
	cin >> t;
	while(t--) {
		//++timerR;
	//cout << "Case #" << timerR << ": ";
		solve();
	}
#ifdef YA
	cout << "\n\n" << (clock() - start) / 1.0 / CLOCKS_PER_SEC << "\n\n";
#endif
	return 0;
}


//#define int li

vector <vector <int> > bits;

void prec() {
	bits.resize((1 << 13) + 1);

	for (int i = 1; i <= (1 << 13); ++i) {
		for (int j = 0; j < 13; ++j) {
			if ((1 << j) & i) {
				bits[i].push_back(j);
			}
		}
	}
}

void normalize(pair <int, int>& t) {
	while (t.second > 0 && bits[t.second].back() == bits[t.first].back()) {
		t.first += (1 << bits[t.second].back());
		t.second -= (1 << bits[t.second].back());
	}
}

void solve() {
	int n;
	vector <int> a;
	cin >> n;
	a.resize(n);

	int sum = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		sum += a[i];
		for (int j = 0;;++j) {
			if ((1 << j) == a[i]) {
				a[i] = j;
				break;
			}
		}
	}
	
	bool f = false;
	int res;

	for (res = 0; res < 14; ++res) {
		if ((1 << res) == sum) {
			f = true;
			break;
		}
	}

	if (!f) {
		cout << "no\n";
		return;
	}

	vector < vector < int > > dp;
	dp.resize(n + 1);
	vector < vector < pair <int, int> > > par;
	par.resize(n + 1);

	dp[1].assign(sum + 1, 0);
	par[1].resize(sum + 1);
	dp[1][1 << a[0]] = 1;
	par[1][1 << a[0]] = mp(0, 0);

	int prefsum = 0;

	for (int i = 1; i < n; ++i) {
		prefsum += (1 << a[i - 1]);

		dp[i + 1].assign(sum + 1, 0);
		par[i + 1].resize(sum + 1);

		for (int j = 1; j < dp[i].size(); ++j) {
			if (dp[i][j]) {
				pair <int, int> t;
				t.first = j;
				t.second = prefsum - j;

				pair <int, int> newt;

				if (bits[t.first][0] >= a[i]) {
					newt = mp(t.first + (1 << a[i]), t.second);
					normalize(newt);
					dp[i + 1][newt.first] = 1;
					par[i + 1][newt.first] = mp(t.first, 0);
				}
				if (t.second == 0 || (t.second != 0 && bits[t.second][0] >= a[i])) {
					newt = mp(t.first, t.second + (1 << a[i]));
					normalize(newt);
					dp[i + 1][newt.first] = 1;
					par[i + 1][newt.first] = mp(t.first, 1);
				}
			}
		}
	}


	if (dp[n][sum]) {
		string res;
		int cur = sum;
		for (int i = n; i >= 1; --i) {
			res.push_back((par[i][cur].second)?('r'):('l'));
			cur = par[i][cur].first;
		}
		reverse(res.begin(), res.end());
		cout << res << "\n";
	}
	else {
		cout << "no\n";
	}
}