#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>
#include <fstream> 
#include <iomanip> 
#include <sstream> 
#include <cmath> 
#include <ctime> 
#include <cctype> 
#include <deque> 

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

template <class T> inline void updMax(T &x, const T &other) { if (x < other) x = other; }
template <class T> inline void updMin(T &x, const T &other) { if (other < x) x = other; }
template <class T> inline T sqr(const T &x) { return x * x; } 

const int MAXN = 1005;
const int MAXK = 9000;

int dyn[MAXN][MAXK];
int used[MAXN][MAXK];
int ITER = 0;
int sumPref[MAXN];
int n;
int isPow2[MAXK];
int arr[MAXN];

void
precalc()
{
	int cur = 1;
	while (cur < MAXK) {
		isPow2[cur] = 1;
		cur *= 2;
	}
}

int
add(int x, int y)
{
	if (x % y) {
		return -1ll;
	}
	return x + y;
}

int
can(int x, int sumR)
{
	if (used[x][sumR] == ITER) {
		return dyn[x][sumR];
	}
	used[x][sumR] = ITER;
	int &res = dyn[x][sumR];
	res = 0;
	if (x == n) {
		if (sumR == sumPref[x] && isPow2[sumR]) {
			res = 1;
		}
	} else {
		int sumL = sumPref[x] - sumR;
		if (!res) { // go left
			int nSumL = add(sumL, arr[x]);
			if (nSumL != -1) {
				if (isPow2[nSumL] && nSumL * 2 > sumR) {
					res = can(x + 1, sumR + nSumL);
				} else {
					res = can(x + 1, sumR);
				}
			}
		}
		if (!res) { // go right
			int nSumR = add(sumR, arr[x]);
			if (nSumR != -1) {
				res = can(x + 1, nSumR);
			}
		}
	}
	return res;
}

void
recover(int x, int sumR)
{
	if (x == n) {
		return;
	}
	int sumL = sumPref[x] - sumR;
	{
		int nSumL = add(sumL, arr[x]);
		if (nSumL != -1) {
			if (isPow2[nSumL] && nSumL * 2 > sumR) {
				if (can(x + 1, sumR + nSumL)) {
					putchar('l');
					recover(x + 1, sumR + nSumL);
					return;
				}
			} else if (can(x + 1, sumR)) {
				putchar('l');
				recover(x + 1, sumR);
				return;
			}
		}
	}
	{
		int nSumR = add(sumR, arr[x]);
		if (nSumR != -1) {
			if (can(x + 1, nSumR)) {
				putchar('r');
				recover(x + 1, nSumR);
				return;
			}
		}
	}
	printf("\nhui");
}

void
process()
{
	scanf("%d", &n);
	sumPref[0] = 0;
	for (int i = 0; i < n; ++i) {
		scanf("%d", &arr[i]);
		sumPref[i + 1] = sumPref[i] + arr[i];
	}
	ITER++;
	int res = can(1, arr[0]);
	if (!res) {
		puts("no");
	} else {
		//puts("yes");
		putchar('r');
		recover(1, arr[0]);
		puts("");
	}
}

int main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
	//freopen(".in", "r", stdin); freopen(".out", "w", stdout);
	
	//ios::sync_with_stdio(false); 
	precalc();
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		process();
	}

	return 0;
}