#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

const int N = 100500;

const int M = 1000;

struct vt
{
	int x, y;
	vt(int _x, int _y)
	{
		x = _x, y = _y;
	}
	friend vt operator +(vt a, vt b)
	{
		return vt(a.x + b.x, a.y + b.y);
	}
	friend vt operator -(vt a, vt b)
	{
		return vt(a.x - b.x, a.y - b.y);
	}
	friend llong operator *(vt a, vt b)
	{
		return a.x * 1ll * b.x + a.y * 1ll * b.y;
	}
	friend llong operator ^(vt a, vt b)
	{
		return a.x * 1ll * b.y - b.x * 1ll * a.y;
	}
	vt(){}
};

struct bucket
{
	vt P[M + 2];
	vt A[M + 2];

	int n, pt;

	void init()
	{
		pt = 0;
		for (int i = 0; i < n; i++)
		{
			while (pt >= 2 && ((A[pt - 1] - A[pt - 2]) ^ (P[i] - A[pt - 1])) >= 0)
				--pt;
			A[pt++] = P[i];
		}
	}

	int go(vt u, vt v, int mni = 0)
	{
		for (int i = mni; i < n; i++)
			if (((v - u) ^ (P[i] - v)) > 0)
				return i;
		return -1;
	}

	bool any(vt u, vt v)
	{
		if (n <= 2)
		{
			int g = go(u, v);
			return (g != -1);
		}
		int a = -1, b = pt - 1;
		while (b - a > 1)
		{
			int m = (a + b) / 2;
			if (((A[m + 1] - A[m]) ^ (v - u)) <= 0)
				a = m;
			else
				b = m;
		}
		vt q = A[a + 1];
		return (((v - u) ^ (q - v)) > 0);
	}
	bucket(){}
} B[N / M + 100];



vt P[N];

int ans[N];

void solve()
{
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
		scanf("%d %d", &P[i].x, &P[i].y);
	for (int i = 0; i < n; i += M)
	{
		int q = i / M;
		B[q].n = 0;
		for (int j = i; j < n && j < i + M; j++)
			B[q].P[B[q].n++] = P[j];
		B[q].init();
	}
	memset(ans, 0, sizeof(int) * (n - 1));
	ans[n - 2] = 0;
	for (int i = n - 3; i >= 0; i--)
	{
		int l = i + 2;
		int f = l / M;
		int g = B[f].go(P[i], P[i + 1], l - f * M);
		ans[i] = 0;
		if (g != -1)
		{
			ans[i] = g + f * M;
		}
		else
		{
			for (int j = f + 1; j * M < n; j++)
			{
				bool an = B[j].any(P[i], P[i + 1]);
				if (an)
				{
					g = B[j].go(P[i], P[i + 1]);
					assert(g != -1);
				}
				if (g != -1)
				{
					ans[i] = g + j * M;
					break;
				}
			}
		}
	}
	for (int i = 0; i < n - 1; i++)
		printf("%d ", ans[i]);
	printf("\n");
}

int main() {
#ifdef LOCAL42
#define TASK "B"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int T;
	scanf("%d", &T);
	for (int i = 0; i < T; i++)
		solve();
	return 0;
}
