#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int K = 14;
const int N = 1010;

int sum[N], a[N];
int go[(1 << K)][K];
int last[(1 << K)];
bool can[N][(1 << K)], is_left[N][(1 << K)];
int prev[N][(1 << K)];
int lst[K + 10], nlst[K + 10];

inline void init() {
	for (int i = 0; i < (1 << K); ++i) {
		int sz = 0;
		for (int j = K - 1; j >= 0; --j) {
			if ((i & (1 << j)) != 0) {
				lst[sz++] = j;
			}
		}
		last[i] = (sz == 0 ? -1 : lst[0]);
		for (int j = 0; j < K; ++j) {
			for (int z = 0; z < sz; ++z) {
				nlst[z] = lst[z];
			}
			int ptr = sz;
			nlst[ptr] = j;
			if (ptr > 0 && nlst[ptr - 1] < nlst[ptr]) {
				go[i][j] = -1;
				continue;
			}
			while (ptr > 0 && nlst[ptr - 1] == nlst[ptr]) {
				++nlst[--ptr];
			}
			int mask = 0;
			for (int z = 0; z <= ptr; ++z) {
				mask |= (1 << nlst[z]);
			}
			go[i][j] = mask;
		}
	}
}

void path(int pref, int mask) {
	if (pref == 0) {
		return;
	}
	path(pref - 1, prev[pref][mask]);
	if (is_left[pref][mask]) {
		printf("l");
	} else {
		printf("r");
	}
}

inline void solve() {
	int n;
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		int cur;
		scanf("%d", &cur);
		a[i] = 0;
		sum[i + 1] = sum[i] + cur;
		while (cur > 1) {
			cur /= 2;
			++a[i];
		}
	}
	assert(sum[n] < (1 << K));
	int val = sum[n], cur = 0;
	while (val > 1 && val % 2 == 0) {
		val /= 2;
		++cur;
	}
	if (val != 1) {
		puts("no");
		return;
	}
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j < (1 << K); ++j) {
			can[i][j] = false;
		}
	}
	can[0][0] = true;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < (1 << K); ++j) {
			if (!can[i][j]) {
				continue;
			}
			// left
			if (go[j][a[i]] != -1) {
				int nj = go[j][a[i]];
				int z = sum[i] - j;
				if (last[z] == last[nj]) {
					int pos = last[nj];
					nj ^= (1 << pos);
					nj |= (1 << (pos + 1));
				} else if (last[z] > last[nj]) {
					if (nj == 0) {
						nj = z;
					} else {
						nj |= ((z >> last[nj]) << last[nj]);
					}
				}
				can[i + 1][nj] = true;
				is_left[i + 1][nj] = true;
				prev[i + 1][nj] = j;
			}
			// right
			if (go[sum[i] - j][a[i]] != -1) {
				int nj = j;
				int z = go[sum[i] - j][a[i]];
				if (last[z] == last[nj]) {
					int pos = last[nj];
					nj ^= (1 << pos);
					nj |= (1 << (pos + 1));
				} else if (last[z] > last[nj]) {
					if (nj == 0) {
						nj = z;
					} else {
						nj |= ((z >> last[nj]) << last[nj]);
					}
				}
				can[i + 1][nj] = true;
				is_left[i + 1][nj] = false;
				prev[i + 1][nj] = j;
			}
		}
	}
	if (can[n][(1 << cur)]) {
		path(n, (1 << cur));
		puts("");
	} else {
		puts("no");
	}
}

int main() {
#ifdef LOCAL42
#define TASK "E"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	init();
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		solve();
	}
	return 0;
}
