#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int M = int(1e5) + 100;
const int N = 1010;
const int SIZE = int(3e7);

struct edge {

	int a, b, c, num;

	edge() {}

	edge(int a, int b, int c, int num) {
		this->a = a;
		this->b = b;
		this->c = c;
		this->num = num;
	}

};

bool operator < (const edge &a, const edge &b) {
	return a.c < b.c;
}

struct node {

	node *l, *r;
	int sum;

};

int maxv, ptr, step = 0;
int p[N], cost[N], num[N], used[N];
edge e[M];
node *root[M];
node rmq[SIZE];
vector<edge> lst;

inline int get_lca(int a, int b) {
	++step;
	while (a != -1) {
		used[a] = step;
		a = p[a];
	}
	while (b != -1 && used[b] != step) {
		b = p[b];
	}
	return b;
}

node* clone(node *v) {
	assert(ptr < SIZE);
	node* res = &rmq[ptr++];
	*res = *v;
	return res;
}

node* update(node *v, int l, int r, int pos, int val) {
	v = clone(v);
	if (l == r) {
		v->sum = val;
		return v;
	}
	int mid = (l + r) / 2;
	if (pos <= mid) {
		v->l = update(v->l, l, mid, pos, val);
	} else {
		v->r = update(v->r, mid + 1, r, pos, val);
	}
	v->sum = v->l->sum + v->r->sum;
	return v;
}

int get_sum(node *v, int gl, int gr, int l, int r) {
	if (gl > r || gr < l) {
		return 0;
	}
	if (gl >= l && gr <= r) {
		return v->sum;
	}
	int mid = (gl + gr) / 2;
	return get_sum(v->l, gl, mid, l, r) + get_sum(v->r, mid + 1, gr, l, r);
}

inline void solve() {
	int n, m;
	scanf("%d %d", &n, &m);
	for (int i = 0; i < m; ++i) {
		scanf("%d %d %d", &e[i].a, &e[i].b, &e[i].c);
		--e[i].a;
		--e[i].b;
	}
	sort(e, e + m);
	maxv = 1;
	while (maxv < m) {
		maxv *= 2;
	}
	for (int i = 0; i < maxv; ++i) {
		rmq[i + maxv].sum = 0;
		rmq[i + maxv].l = rmq[i + maxv].r = NULL;
	}
	for (int i = maxv - 1; i > 0; --i) {
		rmq[i].sum = 0;
		rmq[i].l = &rmq[i * 2];
		rmq[i].r = &rmq[i * 2 + 1];
	}
	node *cur = &rmq[1];
	ptr = 2 * maxv;
	for (int i = 0; i < n; ++i) {
		p[i] = -1;
	}
	for (int i = m - 1; i >= 0; --i) {
		int lca = get_lca(e[i].a, e[i].b), a = e[i].a, b = e[i].b;
		if (lca != -1) {
			pair<int, pii> best(-inf, mp(-1, -1));
			for (int j = e[i].a; j != lca; j = p[j]) {
				best = max(best, mp(cost[j], mp(j, 0)));
			}
			for (int j = e[i].b; j != lca; j = p[j]) {
				best = max(best, mp(cost[j], mp(j, 1)));
			}
			cur = update(cur, 0, maxv - 1, num[best.sc.fs], 0);
			p[best.sc.fs] = -1;
			if (best.sc.sc == 0) {
				swap(a, b);
			}
		}
		lst.clear();
		for (int j = b; p[j] != -1; j = p[j]) {
			lst.pb(edge(j, p[j], cost[j], num[j]));
		}
		reverse(all(lst));
		for (int j = 0; j < sz(lst); ++j) {
			p[lst[j].b] = lst[j].a;
			cost[lst[j].b] = lst[j].c;
			num[lst[j].b] = lst[j].num;
		}
		p[b] = a;
		cost[b] = e[i].c;
		num[b] = i;
		cur = update(cur, 0, maxv - 1, i, e[i].c);
		root[i] = cur;
	}
	int q;
	scanf("%d", &q);
	int ans = 0;
	for (int i = 0; i < q; ++i) {
		int L, H;
		scanf("%d %d", &L, &H);
		L -= ans;
		H -= ans;
		int gl = m, l = 0, r = m - 1;
		while (l <= r) {
			int mid = (l + r) / 2;
			if (e[mid].c >= L) {
				gl = mid;
				r = mid - 1;
			} else {
				l = mid + 1;
			}
		}
		int gr = -1;
		l = 0;
		r = m - 1;
		while (l <= r) {
			int mid = (l + r) / 2;
			if (e[mid].c <= H) {
				gr = mid;
				l = mid + 1;
			} else {
				r = mid - 1;
			}
		}
		if (gl > gr) {
			ans = 0;
		} else {
			ans = get_sum(root[gl], 0, maxv - 1, gl, gr);
		}
		printf("%d\n", ans);
	}
}

inline void gen() {
	freopen("J2.in", "w", stdout);
	cout << 1 << endl;
	cout << 1000 << " " << int(1e5) << endl;
	for (int i = 0; i < int(1e5); ++i) {
		int a = rand() % 1000, b = rand() % 1000;
		while (a == b) {
			a = rand() % 1000;
			b = rand() % 1000;
		}
		cout << a << " " << b << " " << rand() % 10000 << endl;
	}
	cout << int(1e6) << endl;
	for (int i = 0; i < int(1e6); ++i) {
		cout << 0 << " " << int(1e6) << endl;
	}
	exit(0);
}

int main() {
	//gen();
	cerr << "mem = " << sizeof(rmq) / 1024 / 1024 << endl;
#ifdef LOCAL42
#define TASK "J"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int t;
	scanf("%d", &t);
	for (int i = 0; i < t; ++i) {
		solve();
	}
	cerr << 1.0 * clock() / CLOCKS_PER_SEC << endl;
	return 0;
}
