#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));

const int N = 150500;
const int K = 13;
pair<int, int> A[N];
int D[N][K];

bool cmp(pair<int, int> a, pair<int, int> b)
{
	return min(a.first, b.first - a.second) > min(b.first, a.first - b.second);
}

void solve()
{
	int n;
	int k;
	scanf("%d %d", &n, &k);
	for (int i = 0; i < n; i++)
		scanf("%d %d", &A[i].first, &A[i].second);
	++k;
	sort(A, A + n, cmp);
	int a = 0, b = 1e6 + 1;
	while (b - a > 1)
	{
		int m = (a + b) / 2;
		D[0][0] = 0;
		for (int j = 1; j <= k; j++)
			D[0][j] = inf;
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j <= k; j++)
				D[i + 1][j] = inf;
			for (int j = 0; j <= k; j++)
			{
				int mnc = D[i][j];
				D[i + 1][j] = min(D[i + 1][j], mnc);
				if (j != k && A[i].first - A[i].second - mnc >= m)
					D[i + 1][j + 1] = min(D[i + 1][j + 1], mnc + A[i].second);
			}
		}

		if (D[n][k] < inf)
			a = m;
		else
			b = m;
	}
	printf("%d\n", a);
}

void gen()
{
	freopen("K2.in", "w", stdout);
	printf("1\n150000 9\n");
	for (int i = 0; i < 150000; i++)
		printf("%d %d\n", ((rand() << 15) + rand()) % 1000001, ((rand() << 15) + rand()) % 1000001);
	exit(0);
}


int main() {
	//gen();
#ifdef LOCAL42
#define TASK "K"
	freopen(TASK "2.in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	int T;
	scanf("%d", &T);
	for (int i = 0; i < T; i++)
		solve();
	return 0;
}
