#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <bitset>
#include <sstream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <climits>
#include <cctype>
#include <cstdlib>
using namespace std;

#define FOR(i,a,b) for(int i=(a);i<(b);i++)
#define ROF(i,a,b) for(int i=(b)-1;i>=(a);i--)
#define REOPEN(i,o) do{freopen(i,"rt",stdin);freopen(o,"wt",stdout);}while(0)

typedef long long LL;
typedef LL ll;
typedef pair<int, int> pii;
const int INF = 1000000000;
const LL LINF = 1000000000000000000LL;
const double PI = 3.1415926535897932384626433832795;

LL gcd(LL a, LL b) {
  if (a < 0) a = -a;
  while (b) {
    LL t = a;
    a = b;
    b = t % b;
  }
  return a;
}

struct Wheel {
  int x, y, r;
  LL p, q;
};
Wheel wheels[1024];
int vq[1024];

int sqr(int x) {
  return x * x;
}

void test() {
  int n;
  scanf("%d", &n);
  FOR(i, 0, n) scanf("%d%d%d", &wheels[i].x, &wheels[i].y, &wheels[i].r), wheels[i].p = wheels[i].q;
  wheels[0].p = wheels[0].q = 1;
  int qh = 0, qt = 0;
  vq[qh++] = 0;
  while (qh > qt) {
    int v = vq[qt++];
    FOR(j, 0, n) {
      if (wheels[j].q) continue;
      if (sqr(wheels[j].x - wheels[v].x) + sqr(wheels[j].y - wheels[v].y) == sqr(wheels[j].r + wheels[v].r)) {
        wheels[j].p = -wheels[v].p * wheels[v].r;
        wheels[j].q = wheels[v].q * wheels[j].r;
        LL d = gcd(wheels[j].p, wheels[j].q);
        wheels[j].p /= d;
        wheels[j].q /= d;
        vq[qh++] = j;
      }
    }
  }
  FOR(i, 0, n) {
    if (wheels[i].q) {
      if (wheels[i].p > 0) {
        if (wheels[i].q > 1) {
          printf("%lld/%lld clockwise\n", wheels[i].p, wheels[i].q);
        } else {
          printf("%lld clockwise\n", wheels[i].p);
        }
      } else {
        if (wheels[i].q > 1) {
          printf("%lld/%lld counterclockwise\n", -wheels[i].p, wheels[i].q);
        } else {
          printf("%lld counterclockwise\n", -wheels[i].p);
        }
      }
    } else {
      printf("not moving\n");
    }
  }
}

int main() {
  int T;
  scanf("%d", &T);
  FOR(i, 0, T) test();
  return 0;
}
