#include <iostream>

using namespace std;

const int MAXN = 1005;
int x[MAXN], y[MAXN], r[MAXN], ansp[MAXN], ansq[MAXN], n;
char used[MAXN], dir[MAXN];

int gcd(int a, int b) {
    return b? gcd(b, a % b) : a;
}

int sqDist(int x0, int y0, int x1, int y1) {
    return (x1 - x0) * (x1 - x0) + (y1 - y0) * (y1 - y0);
}

void dfs(int v) {
    used[v] = true;
    for(int i = 0; i < n; i++)
        if(!used[i] && sqDist(x[v], y[v], x[i], y[i]) == (r[v] + r[i]) * (r[v] + r[i])) {
            ansp[i] = ansp[v] * r[v];
            ansq[i] = ansq[v] * r[i];
            int g = gcd(ansp[i], ansq[i]);
            ansp[i] /= g;
            ansq[i] /= g;
            dir[i] = !dir[v];
            dfs(i);
        }
}

int main() {
    ios_base::sync_with_stdio(false);
    int t;
    cin >> t;
    for(int tt = 0; tt < t; tt++) {
        cin >> n;
        for(int i = 0; i < n; i++)
            cin >> x[i] >> y[i] >> r[i];
        for(int i = 0; i < n; i++) {
            ansp[i] = 0;
            ansq[i] = 1;
            dir[i] = false;
            used[i] = false;
        }
        ansp[0] = 1;
        ansq[0] = 1;
        dfs(0);
        for(int i = 0; i < n; i++) {
            if(!ansp[i])
                cout << "not moving\n";
            else {
                cout << ansp[i];
                if(ansq[i] != 1)
                    cout << '/' << ansq[i];
                if(dir[i])
                    cout << " counterclockwise\n";
                else
                    cout << " clockwise\n";
            }
        }
    }
    return 0;
}
