#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <limits.h>
#include <queue>
#include <stack>
#include <deque>
#include <set>
#include <map>
#include <utility>
#include <stdio.h>
#include <time.h>
#include <memory.h>
#include <string.h>
#include <assert.h>
using namespace std;

#define EPS 1E-7
const long long MOD = 1000000007;
#define mp make_pair

struct pt2{
	long long x,y;
};

struct circle{
	long long x,y,r;
	circle(){}
	pt2 center(){
		pt2 res;
		res.x=x;
		res.y=y;
		return res;
	}
};

long long gcd(long long a, long long b){
	if(a==0 && b==0)return 1;
	if(!b)return a;
	return gcd(b,a%b);
}

long long ABS(long long a){
	return a>0 ? a : -a;
}

struct frac{
	long long up,down;

	frac(){};
	frac(long long w){
		frac res;
		res.up=w;
		res.down=1;
	}
	frac(long long u, long long d){
		frac res;
		res.up=u;
		res.down=d;
	}
	void reduce(){
		if(down<0){
			up=-up;
			down=-down;
		}
		long long g = gcd(ABS(up), ABS(down));
		up/=g;
		down/=g;
	}
	frac operator *(const frac&b){
		frac res;
		res.up = up*b.up;
		res.down = down*b.down;
		res.reduce();
		return res;
	}
};


long long sqdist(pt2 a, pt2 b){
	long long dx = a.x-b.x;
	long long dy = a.y-b.y;
	return dx*dx+dy*dy;
}

bool touch(circle & a, circle & b){
	return sqdist(a.center(), b.center()) == (a.r + b.r)*(a.r + b.r);
}

vector<int>used(1001);
vector<frac>res(1001);
vector<circle>vec;
vector<vector<int>>g;
vector<int>dist(1001);

void print(frac & a, int v){
	if(a.down==1){
		if(dist[v]%2 == 0){
			cout << a.up << " " << "clockwise" << endl;
		}
		else{
			cout << a.up << " " << "counterclockwise" << endl;
		}
	}
	else{
		if(dist[v]%2 == 0){
			cout << a.up << "/" << a.down << " " << "clockwise" << endl;
		}
		else{
			cout << a.up << "/" << a.down << " " << "counterclockwise" << endl;
		}
	}
}

void go(int v, int dis){
	dist[v]=dis;
	used[v]=1;
	for(int i=0; i<g[v].size(); ++i){
		int to = g[v][i];
		if(!used[to]){
			used[to]=1;
			frac w;
			w.up = vec[i].r;
			w.down = vec[to].r;
			w.reduce();
			res[to] = res[i]*w;
			go(to,dis+1);
		}
	}
}

int main(){
	freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
	int t;
	cin>>t;
	for(int TT=0;TT<t;++TT){
		int n;
		cin>>n;

		frac emp;
		emp.up=0;
		emp.down=1;

		used.assign(1001,0);
		res.assign(1001,emp);
		dist.assign(1001,999999);
		vec.clear();
		vec.resize(n);

		

		long long a,b,c;
		for(int i=0; i<n; ++i){
			cin>>a>>b>>c;
			vec[i].x=a;vec[i].y=b;vec[i].r=c;
		}
		g.resize(n);
		for(int i=0; i<n; ++i){
			for(int j=i+1; j<n; ++j){
				if(touch(vec[i], vec[j])){
					g[i].push_back(j);
					g[j].push_back(i);
				}
			}
		}

		queue<int>q;
		int curr,to;

		used[0]=1;

		emp.up=1;
		res[0]=emp;

		dist[0]=0;

		go(0,0);

		for(int i=0; i<n; ++i){
			if(!used[i]){
				puts("not moving");
			}
			else{
				print(res[i], i);
			}
		}
	}



	return 0;
}