#include <algorithm>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstring>
#include <iostream>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <vector>
using namespace std;

typedef pair<int, int> ii;
typedef vector<int> vi;
typedef vector<ii> vii;
typedef vector<vector<int> > vvi;
typedef long long ll;
template <class T> int size(const T& x) {return x.size();}

const double EPS = 1e-9;
const int INF = 2147483647;

int main() {

    int ts;
    scanf("%d\n", &ts);

    for (int t = 0; t < ts; t++) {
        int N;
        scanf("%d\n", &N);

        bool found = false;

        for (int d = 2; (ll)d*(d+1)/2 <= N; d++) {

            ll n = 2*N + d - (ll)d * d;
            if (n % (2*d) != 0)
                continue;

            n /= 2 * d;

            int start = n;
            int end = n + d - 1;
            if (start <= 0 || end <= 0 || start >= end) {
                continue;
            }

            printf("%d =", N);

            for (int i = n; i < n + d; i++) {
                if (i != n) printf(" +");
                printf(" %d", i);
            }

            printf("\n");
            found = true;

            break;
        }

        if (!found) printf("IMPOSSIBLE\n");
    }

    return 0;
}
