#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <cstring>
#include <cstdio>
#include <ctime>
#include <cassert>
#include <vector>
#include <queue>
#include <cmath>

#define fr first
#define sc second
#define mp make_pair
#define pb push_back 

using namespace std;

const int N = 1e3 + 10;
const int INF = 1e9;

int gcd(int a, int b) {
	return (b == 0)? a: gcd(b, a % b);
}

struct frac {
	int p, q;
	bool dir;
	frac() { }
	frac(int _p, int _q, bool _dir) {
		int d = gcd(_p, _q);
		p = _p / d;
		q = _q / d;
		dir = _dir;
	}
	frac operator * (frac A) {
		return frac(p * A.p, q * A.q, dir ^ A.dir);	
	}
	void print() {
		if (p == 0) {
			printf("not moving\n");
			return;
		}
		if (q == 1) {
			printf("%d ", p);
		}
		else {
			printf("%d/%d ", p, q);
		}
		if (dir)
			printf("counter");
		printf("clockwise\n");
	}
};

bool use[N];
frac a[N];
int x[N];
int y[N];
int r[N];
int n; 

int sqr(int x) {
	return x * x;
}

bool check(int i, int j) {
	int len = sqr(x[i] - x[j]) + sqr(y[i] - y[j]);
	int r2 = sqr(r[i] + r[j]);
	return r2 == len;
}

void dfs(int v) {
	use[v] = 1;
	for (int i = 0; i < n; i++)
		if (!use[i] && check(i, v)) {
			a[i]  = a[v] * frac(r[v], r[i], 1);
			dfs(i);
		}
}


int main() {
#ifdef DEBUG
	freopen("in", "r", stdin);
#endif
	int T;
	scanf("%d", &T);		
	for (int tt = 0; tt < T; tt++) {
		scanf("%d", &n);	
		for (int i = 0; i < n; i++)
			scanf("%d%d%d", &x[i], &y[i], &r[i]);

		memset(use, 0, sizeof(use));
		for (int i = 0; i < n; i++)
			a[i] = frac(0, 1, 0);
		a[0] = frac(1, 1, 0);
		dfs(0);
		for (int i = 0; i < n; i++)
			a[i].print();
	}

	return 0;
}

