#if 1
#include <functional>
#include <algorithm>
#include <iostream>
#include <iterator>
#include <iomanip>
#include <sstream>
#include <numeric>
#include <string>
#include <vector>
#include <bitset>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <cstdlib>
#include <cassert>
#include <cstring>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <list>
 
using namespace std;
 
typedef long long LL;
typedef long double LD;
typedef pair<int, int> pii;
 
const LD eps = 1e-9;
const LD pi = acos(-1.0);
const LL inf = 1e+9;
 
#define mp make_pair
#define pb push_back
#define X first
#define Y second
 
#define dbg(x) { cerr << #x << " = " << x << endl; }
 
// extended template
#pragma comment(linker, "/STACK:36777216")
typedef vector<int> vi;
typedef vector<vi> vvi;
 
#define forn(i, n) for (int i = 0; i < n; ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
 
template<typename T> istream & operator >> (istream &, vector<T> &);
template<typename T> ostream & operator << (ostream &, const vector<T> &);
 
#define START clock_t _clock = clock();
#define END cerr << endl << "time: " << (clock() - _clock) / LD(CLOCKS_PER_SEC) << endl;
 
#define NAME "problem"

//namespace solution
//{

LL gcd(LL a, LL b)
{
    while(b)
    {
        a %= b;
        swap(a, b);
    }
    return a;
}
struct frac_t
{
    LL x, y;
    frac_t() { x = 0, y = 1; }
    frac_t(LL xx, LL yy)
    {
        x = xx, y = yy;
        LL g = gcd(abs(x), abs(y));
        x /= g, y /= g;
        if (y < 0)
            x *= -1, y *= -1;
    }
    friend frac_t operator * (const frac_t &a, const frac_t &b)
    {
        return frac_t(a.x * b.x, a.y * b.y);
    }
    void print()
    {
        if(x == 0)
        {
            cout << "not moving" << endl;
            return;
        }

        cout << abs(x);
        if (y != 1)
            cout << "/" << abs(y);
        cout << (x < 0 ? " counterclockwise" : " clockwise") << endl;
    }
};


const int maxn = 1000 + 10;
int n;
int x[maxn], y[maxn], r[maxn];

LL dist2(int i, int j)
{
    return LL(x[i] - x[j]) * LL(x[i] - x[j]) +
           LL(y[i] - y[j]) * LL(y[i] - y[j]);
}

vvi g;
vi used;
int vert = 0;
int edges = 0;

void dfs(int s)
{
    ++vert;
    used[s] = true;
    forn(i, g[s].size())
    {
        int to = g[s][i];
        if (!used[to])
        {
            ++edges;
            dfs(to);
        }
    }
}

vector<frac_t> speed;
void dfs2(int s)
{
    used[s] = true;
    forn(i, g[s].size())
    {
        int to = g[s][i];
        if (!used[to])
        {
            speed[to] = speed[s] * frac_t(-r[s], r[to]);
            dfs2(to);
        }
    }
}

void solve()
{
    cin >> n;
    forn(i, n)
        cin >> x[i] >> y[i] >> r[i];
    g.assign(n, vi());

    for (int i = 0; i < n; ++i)
        for (int j = i + 1; j < n; ++j)
            if (dist2(i, j) == LL(r[i] + r[j]) * (r[i] + r[j]))
            {
                g[i].push_back(j);
                g[j].push_back(i);
            }

    speed.assign(n, frac_t());

    vert = 0;
    edges = 0;
    used.assign(n, false);
    dfs(0);

    if (edges == vert - 1)
    {
        speed[0] = frac_t(1, 1);
        used.assign(n, false);
        dfs2(0);
    }

    forn(i, n)
        speed[i].print();
}

//}
 
int main()
{
    // freopen(NAME ".in", "r", stdin); freopen(NAME ".out", "w", stdout);
    // freopen("input.txt", "r", stdin); // freopen("output.txt", "w", stdout);
 
    ios_base::sync_with_stdio(false);

    int t; cin >> t;
    while (t--)
        /*solution::*/solve();
 
    return 0;
}
/*******************************************
*******************************************/
 
template<typename T> istream & operator >> (istream &is, vector<T> &v)
{
    forn(i, v.size())
        is >> v[i];
    return is;
}
template<typename T> ostream & operator << (ostream &os, const vector<T> &v)
{
    forn(i, v.size())
        os << v[i] << " ";
    return os;
}
#endif